!= Subroutine BasicEnv
!
! Authors::   SUGIYAMA Koichiro, ODAKA Masatsugu
! Version::   $Id: basicenv_smooth2.f90,v 1.1 2012-09-10 01:53:27 yamasita Exp $
! Tag Name::  $Name: arare4-20120911 $
! Copyright:: Copyright (C) GFD Dennou Club, 2006. All rights reserved.
! License::   See COPYRIGHT[link:../../COPYRIGHT]
!
!== Overview 
!
!ǥեȤδܾꤹ뤿ѿȷ⥸塼
!   * BasicEnvFile_init: ܾͤ netCDF ե뤫
!   * BasicEnvCalc_Init: ܾξ Namelist ͤ׻
!
!== Error Handling
!
!== Known Bugs
!
!== Note
!
!== Future Plans
!

subroutine BasicEnv()
  !
  !ǥեȤδܾꤹ뤿Υ֥롼. 
  !ܾ׻, BasicSet ⥸塼ͤ. 
  !
  !ѥν꤫, ܾ(hogeBasicZ ѿ)
  !׻ʬBasicSet ⥸塼뤫ڤΥƤ. 
  !ECCM Ϥ, BasicSet Τ˰¸뤬 hogeBasicZ  use ʤ
  !֥롼Ѥ뤿Ǥ. 
  !

  !⥸塼ɤ߹
  use dc_message, only: MessageNotify

  use gridset,  only: DimXMin,       &! X β
    &                 RegXMin,       &! X β
    &                 DimXMax,       &! X ξ
    &                 RegXMax,       &! X ξ
    &                 DimZMin,       &! Z β
    &                 RegZMin,       &! Z β
    &                 DimZMax,       &! Z ξ
    &                 RegZMax,       &! X ξ
    &                 SpcNum,        &!Žʬο
    &                 s_Z,           &!顼ʻǤι
    &                 DelZ            !Z γʻֳ
  use basicset, only: BasicSetArray_Init, &!
    &                 PressBasis,    &!̤δవ
    &                 GasRDry,       &!ʬ갵Ǯ
    &                 CpDry,         &!ʬ갵Ǯ
    &                 CvDry,         &!ʬǮ
    &                 MolWtDry,      &!ʬʬ
    &                 Grav,          &!ϲ®
    &                 SpcWetMolFr,   &!Žʬν
    &                 MolWtWet,      &!Žʬʬ
    &                 EnvType,       &!ܾ
    &                 Tropopause,    &!ή̹
    &                 GasRUniv,      &!
    &                 Humidity,      &!ܾм
    &                 TempStrat,     &!طβ [k]
    &                 Dhight,        & !ŤߴؿΥѥ᡼ [m]
    &                 TempSfc,       &
    &                 PressSfc
  use Boundary, only: BoundaryXCyc_xz,  &!
    &                 BoundaryZSym_xz,  &!  
    &                 BoundaryXCyc_xza, &!
    &                 BoundaryZSym_xza   !  
  use ECCM,     only: ECCM_Dry,         &!
    &                 ECCM_Wet
  use cloudset, only: SatRtWetAdia
  use ChemData, only: ChemData_SVapPress_AntoineA, &
    &                 ChemData_SVapPress_AntoineB
  
  !ۤηػ
  implicit none

  !ѿ
  real(8) :: xz_DensBasicZ(DimXMin:DimXMax, DimZMin:DimZMax)
  real(8) :: xz_PressBasicZ(DimXMin:DimXMax, DimZMin:DimZMax)
  real(8) :: xz_ExnerBasicZ(DimXMin:DimXMax, DimZMin:DimZMax)
  real(8) :: xz_TempBasicZ(DimXMin:DimXMax, DimZMin:DimZMax)
  real(8) :: xz_PotTempBasicZ(DimXMin:DimXMax, DimZMin:DimZMax)
  real(8) :: xz_VelSoundBasicZ(DimXMin:DimXMax, DimZMin:DimZMax)
  real(8) :: xza_MixRtBasicZ(DimXMin:DimXMax, DimZMin:DimZMax, SpcNum)
  real(8) :: xz_EffMolWtBasicZ(DimXMin:DimXMax, DimZMin:DimZMax)
  real(8) :: z_TempBasicZ(DimZMin:DimZMax)
  real(8) :: z_PressBasicZ(DimZMin:DimZMax)
  real(8) :: MolFrIni(SpcNum)
  real(8) :: xza_MolFr(DimXMin:DimXMax, DimZMin:DimZMax, SpcNum)
  real(8) :: za_MolFr(DimZMin:DimZMax, SpcNum)
  real(8) :: xza_MixRtDivMolWt(DimXMin:DimXMax, DimZMin:DimZMax, SpcNum)
  real(8) :: z_DTempDZ(DimZMin:DimZMax)
  real(8) :: z_MolWtMean(DimZMin:DimZMax)
  real(8) :: DTempDZ(DimXMin:DimXMax, DimZMin:DimZMax)
  real(8) :: Weight1(DimXMin:DimXMax, DimZMin:DimZMax)
  real(8) :: Weight2(DimXMin:DimXMax, DimZMin:DimZMax)
  real(8) :: LapseRateRatio ! ǮΨФ벼ؤǤβٸΨ
                            ! Ǯ⾮ꤹ. 
  real(8) :: xz_TempAdia(DimXMin:DimXMax, DimZMin:DimZMax)
                                     ! Ǯ˱ä
  real(8) :: xz_TempSat(DimXMin:DimXMax, DimZMin:DimZMax)
                                     ! ŷ˱ä
  real(8) :: xz_TempIso(DimXMin:DimXMax, DimZMin:DimZMax)
                                     ! ˱ä
  real(8) :: xz_PressAdia(DimXMin:DimXMax, DimZMin:DimZMax)
  real(8) :: xz_PressSat(DimXMin:DimXMax, DimZMin:DimZMax)
  real(8) :: xz_PressIso(DimXMin:DimXMax, DimZMin:DimZMax)
  real(8) :: xz_TempWork(DimXMin:DimXMax, DimZMin:DimZMax)
  real(8) :: xz_PressWork(DimXMin:DimXMax, DimZMin:DimZMax)
  real(8) :: xz_Z(DimXMin:DimXMax, DimZMin:DimZMax)
                                     ! 2D ɸ
  real(8) :: RKWork1(DimXMin:DimXMax, DimZMin:DimZMax) 
    ! 󥲡åˡǷ׻ԤʤݤѤѿ
  real(8) :: RKWork2(DimXMin:DimXMax, DimZMin:DimZMax)
    ! 󥲡åˡǷ׻ԤʤݤѤѿ
  real(8) :: RKWork3(DimXMin:DimXMax, DimZMin:DimZMax)
    ! 󥲡åˡǷ׻ԤʤݤѤѿ
  real(8) :: RKWork4(DimXMin:DimXMax, DimZMin:DimZMax)
    ! 󥲡åˡǷ׻ԤʤݤѤѿ
  real(8) :: Temp_0, Temp_1, Press_0, Press_1
                 ! ǮȼǮȤ٤ȿˡǵ
                 ! ݤѤѿ
  real(8) :: Work ! ѿ
  real(8) :: LCL ! ؤβʬۤȼǮ
  real(8) :: LTP ! Ǯ
  real(8) :: Gamma_1, Gamma_2, Gamma_3
                 ! 3 Ĥΰ켡ؿǲʬۤ³ݤγƲٸΨ
  real(8) :: HTrans
                 ! ³򳫻Ϥ
  real(8) :: LCLFunc
                 ! LCL ٤κȴؿ
  real(8) :: LCLFuncDeriv
                 ! LCL ٤κȴؿƳؿ
  real(8) :: Height_1
  real(8) :: Height_2
                 ! LCL ٤κѿ
!  real(8) :: xz_LCL(DimXMin:DimXMax, DimZMin:DimZMax) 
!             ! ؤβʬۤȼǮ
!  real(8) :: xz_LTP(DimXMin:DimXMax, DimZMin:DimZMax) 
!             ! ؤβʬۤȼǮ
  integer :: i, k, s

  !---------------------------------------------------------------
  ! ν
  !---------------------------------------------------------------
  xz_PressBasicZ    = 0.0d0
  xz_ExnerBasicZ    = 0.0d0
  xz_TempBasicZ     = 0.0d0
  xz_PotTempBasicZ  = 0.0d0
  xz_VelSoundBasicZ = 0.0d0
  xza_MixRtBasicZ   = 0.0d0
  xz_EffMolWtBasicZ = 0.0d0
!  z_TempBasicZ      = 0.0d0
  z_TempBasicZ      = TempSfc
  z_PressBasicZ     = 0.0d0
  za_MolFr          = 0.0d0

  ! ɸν
    do k = DimZMin, DimZMax
       xz_Z(:,k) = s_Z(k)
    end do

  !---------------------------------------------------------------
  ! EnvType 򸵤, , , 
  !---------------------------------------------------------------
  MolFrIni = SpcWetMolFr(1:SpcNum) 

  !ʬ. Dry ʤ鴥ǮŪ, Wet ʤ鼾ǮŪʽ
  select case(EnvType)
  case("Dry")
    call ECCM_Dry( MolFrIni, Humidity, z_TempBasicZ, &
      &         z_PressBasicZ, z_MolWtMean, za_MolFr )
  case("Wet")
    call ECCM_Wet( MolFrIni, Humidity, z_TempBasicZ, &
      &         z_PressBasicZ, z_MolWtMean, za_MolFr )

  end select


! ̼齤׻δܾ(˴ǤŵŪ٥ץե)ɤ. 
! * ٸۤϢ³ä, ŤդؿǤʤ餫³. 
! * ܾβʬۤĶǮ, ˰¤Ȥʤʤ褦Ĵ. 

     if (TempSfc <= 300.0d0 ) then

       ! ǮΨФ벼ؤβٸΨ
       LapseRateRatio = 1.0d0 

!       xz_TempAdia = TempSfc - Grav * xz_Z / CpDry
       xz_TempAdia = TempSfc - LapseRateRatio * Grav * xz_Z / CpDry
       xz_TempIso  = TempStrat

       !--- Ǯ, Ǯ, ٤׻,
       !--- ΰΩļѤƲ, Ϥ׻

       !--- ǮȼǮ(LCL)ȿˡǷ׻
       Press_0 = PressSfc
       Temp_0 = TempSfc
       do
         Temp_1 = ChemData_SVapPress_AntoineB(12) / &
              & (ChemData_SVapPress_AntoineA(12) - dlog(Press_0/SatRtWetAdia))
         Press_1 = PressSfc * &
              & (Temp_1/TempSfc)**(CpDry / (LapseRateRatio * GasRDry))
         if (abs(Temp_1 - Temp_0) < epsilon(0.0d0)) then
            LCL = (TempSfc * CpDry) / (Grav * LapseRateRatio) &
              &   * (1.0d0 - (Press_1/PressSfc)**( GasRDry/CpDry ))
           exit
         else
           Temp_0 = Temp_1
           Press_0 = Press_1
         end if
       end do

       !--- Ǯ(LTP)׻
       LTP = LCL + GasRDry * ChemData_SVapPress_AntoineB(12) &
              & / Grav * dlog(Temp_1/xz_TempIso(1,1))

       !--- LCL, LTP ͤɽ(Ǥ Newton ˡνͤѤ)
        write(*,*) 'LCL', LCL
        write(*,*) 'LTP', LTP

       !--- ¿ʳŪ³ΤѤ 1 ؿβٸΨ׻

        Gamma_1 = &
          & 0.75d0 * Grav / CpDry + 0.25d0 * Grav / GasRDry &
          & / ChemData_SVapPress_AntoineB(12) * Temp_1
        Gamma_2 = &
          & 0.50d0 * Grav / CpDry + 0.50d0 * Grav / GasRDry &
          & / ChemData_SVapPress_AntoineB(12) * Temp_1
        Gamma_3 = &
          & 0.25d0 * Grav / CpDry + 0.75d0 * Grav / GasRDry &
          & / ChemData_SVapPress_AntoineB(12) * Temp_1

        write(*,*) 'Gamma1', Gamma_1
        write(*,*) 'Gamma2', Gamma_2
        write(*,*) 'Gamma3', Gamma_3

       !--- ³򳫻Ϥ

        HTrans = LCL - 3.0 * DelZ

       !--- ʤ餫³Ȥ LCL  Newton ˡǵ

        Height_1 = LCL

       do
         LCLFunc = &
           & dlog(PressSfc) &
           & + CpDry / GasRDry * dlog(1.0d0 - Grav * HTrans / CpDry / TempSfc) &
           & + Grav / GasRDry / Gamma_1 * ( &
           &   dlog( &
           &     - Height_1 / 3.0d0 + TempSfc / Gamma_1 &
           &     + (1.0d0/3.0d0 - Grav / CpDry / Gamma_1) * HTrans ) &
           &   - dlog( TempSfc / Gamma_1 - Grav / CpDry / Gamma_1 * HTrans) ) &
           & + Grav / GasRDry / Gamma_2 * ( &
           &   dlog( &
           &     - (1.0d0 + Gamma_1 / Gamma_2) * Height_1 / 3.0d0 &
           &     + TempSfc / Gamma_2 &
           &     + ( Gamma_1 / Gamma_2 / 3.0d0 - Grav / CpDry / Gamma_2 &
           &         + 1.0d0/3.0d0 ) * HTrans ) &
           &   - dlog( &
           &     - Gamma_1 * Height_1 / Gamma_2 / 3.0d0 + TempSfc / Gamma_2 &
           &     + ( Gamma_1 / Gamma_2 / 3.0d0 - Grav / CpDry / Gamma_2 &
           &       ) * HTrans ) )&
           & + Grav / GasRDry / Gamma_3 * ( &
           &   dlog( &
           &     - (1.0d0 + Gamma_2 / Gamma_3 + Gamma_1 / Gamma_3) &
           &       * Height_1 / 3.0d0 &
           &     + TempSfc / Gamma_3 &
           &     + ( - Grav / CpDry / Gamma_3 + Gamma_1 / Gamma_3 / 3.0d0 &
           &         + Gamma_2 / Gamma_3 / 3.0d0 + 1.0d0/3.0d0 )  * HTrans ) &
           &   - dlog( &
           &     - (Gamma_2 / Gamma_3 + Gamma_1 / Gamma_3) &
           &       * Height_1 / 3.0d0 &
           &     + TempSfc / Gamma_3 &
           &     + ( - Grav / CpDry / Gamma_3 + Gamma_1 / Gamma_3 / 3.0d0 &
           &         + Gamma_2 / Gamma_3 / 3.0d0) * HTrans ) ) &
           & - ChemData_SVapPress_AntoineA(12) &
           & + ChemData_SVapPress_AntoineB(12) / &
           &   ( - ( Gamma_1 + Gamma_2 + Gamma_3 ) * Height_1 / 3.0d0 &
           &     + TempSfc &
           &     + ( - Grav / CpDry &
           &         + ( Gamma_1 + Gamma_2 + Gamma_3 ) / 3.0d0) * HTrans )

         write(*,*) 'LCLFunc', LCLFunc

         LCLFuncDeriv = &
           & - Grav / GasRDry / Gamma_1 / 3.0d0 &
           &   / ( - Height_1 / 3.0d0 + TempSfc / Gamma_1 &
           &       + (1.0d0/3.0d0 - Grav / CpDry / Gamma_1) * HTrans ) &
           & + Grav / GasRDry / Gamma_2 * ( &
           &   - (1.0d0 + Gamma_1 / Gamma_2) / 3.0d0 &
           &   / ( - (1.0d0 + Gamma_1 / Gamma_2) * Height_1 / 3.0d0 &
           &       + TempSfc / Gamma_2 &
           &       + ( Gamma_1 / Gamma_2 / 3.0d0 - Grav / CpDry / Gamma_2 &
           &           + 1.0d0/3.0d0 ) * HTrans ) &
           &   + Gamma_1 / Gamma_2 / 3.0d0 &
           &   / ( - Gamma_1 * Height_1 / Gamma_2 / 3.0d0 &
           &       + TempSfc / Gamma_2 &
           &       + ( Gamma_1 / Gamma_2 / 3.0d0 - Grav / CpDry / Gamma_2 &
           &         ) * HTrans ) ) &
           & + Grav / GasRDry / Gamma_3 * ( &
           &   - (1.0d0 + Gamma_2 / Gamma_3 + Gamma_1 / Gamma_3) / 3.0d0 &
           &   / ( - (1.0d0 + Gamma_2 / Gamma_3 + Gamma_1 / Gamma_3) &
           &       * Height_1 / 3.0d0 &
           &     + TempSfc / Gamma_3 &
           &     + ( - Grav / CpDry / Gamma_3 + Gamma_1 / Gamma_3 / 3.0d0 &
           &         + Gamma_2 / Gamma_3 / 3.0d0 + 1.0d0/3.0d0 * HTrans ) ) &
           &   + (Gamma_2 / Gamma_3 + Gamma_1 / Gamma_3) / 3.0d0 &
           &   / ( - (Gamma_2 / Gamma_3 + Gamma_1 / Gamma_3) &
           &       * Height_1 / 3.0d0 &
           &       + TempSfc / Gamma_3 &
           &       + ( - Grav / CpDry / Gamma_3 + Gamma_1 / Gamma_3 / 3.0d0 &
           &           + Gamma_2 / Gamma_3 / 3.0d0) * HTrans ) ) &
           & + ( Gamma_1 + Gamma_2 + Gamma_3 ) &
           &   * ChemData_SVapPress_AntoineB(12) / 3.0d0 &
           &   / ( - ( Gamma_1 + Gamma_2 + Gamma_3 ) * Height_1 / 3.0d0 &
           &       + TempSfc &
           &       + ( - Grav / CpDry &
           &           + ( Gamma_1 + Gamma_2 + Gamma_3 ) / 3.0d0) * HTrans)**2

         Height_2 = Height_1 - LCLFunc / LCLFuncDeriv

         if (abs(Height_2 - Height_1) < epsilon(0.0e0)) then
            LCL = Height_2
            Temp_1 = &
              & - ( Gamma_1 + Gamma_2 + Gamma_3 ) * LCL / 3.0d0 &
              & + TempSfc &
              & + ( - Grav / CpDry &
              &     + ( Gamma_1 + Gamma_2 + Gamma_3 ) / 3.0d0) * HTrans
            write(*,*) 'LCL', LCL
            write(*,*) 'TLCL', Temp_1
           exit
         else
           Height_1 = Height_2
            write(*,*) 'Height1', Height_1
         end if
       end do

       !--- Ǯ(LTP)Ʒ׻
       LTP = LCL + GasRDry * ChemData_SVapPress_AntoineB(12) &
              & / Grav * dlog(Temp_1/xz_TempIso(1,1))
       write(*,*) 'LTP', LTP

    do k = DimZMin, DimZMax
       if (s_Z(k) <= HTrans ) then
          xz_TempBasicZ(:,k) = xz_TempAdia(:,k)
       else if ( (s_Z(k) >= HTrans) .and. (s_Z(k) < LCL/3.0d0 + 2.0d0*HTrans/3.0d0)) then
          xz_TempBasicZ(:,k) = - Gamma_1 * s_Z(k) &
            & + TempSfc + (Gamma_1 - Grav / CpDry) * HTrans
       else if ( (s_Z(k) >= LCL/3.0d0 + 2.0d0*HTrans/3.0d0) .and. (s_Z(k) < 2.0d0*LCL/3.0d0 + HTrans/3.0d0)) then
          xz_TempBasicZ(:,k) = - Gamma_2 * s_Z(k) &
            & + (Gamma_2 - Gamma_1) * LCL / 3.0d0 + TempSfc &
            & + (- Grav / CpDry + Gamma_1 / 3.0d0 + 2.0d0 * Gamma_2 / 3.0d0) &
            &   * HTrans
       else if ( (s_Z(k) >= 2.0d0*LCL/3.0d0 + HTrans/3.0d0) .and. (s_Z(k) < LCL)) then
          xz_TempBasicZ(:,k) = - Gamma_3 * s_Z(k) &
            & + (2.0d0 * Gamma_3 - Gamma_2 - Gamma_1 ) * LCL / 3.0d0 &
            & + TempSfc &
            & + (- Grav / CpDry &
            &    + Gamma_1 / 3.0d0 + Gamma_2 / 3.0d0 + Gamma_3 / 3.0d0) &
            &   * HTrans
       else if ((s_Z(k) >= LCL) .and. (s_Z(k) < LTP)) then
          xz_TempBasicZ(:,k) = &
             &  Temp_1 * dexp(-Grav * (s_Z(k) - LCL) &
             & /(GasRDry*ChemData_SVapPress_AntoineB(12)))
       else
          xz_TempBasicZ(:,k) = xz_TempIso(:,k)
       end if
    end do

     else
        stop 'Tha value of TempSfc is invalid.'
     end if

  ! ʬۤϲŪ˵᤿ΤͿ. 

    do k = DimZMin, DimZMax
       if (s_Z(k) <= HTrans ) then
          xz_PressBasicZ(:,k) = &
            & PressSfc &
            & * (1.0d0 - Grav * s_Z(k) / CpDry / TempSfc)**(CpDry/GasRDry)
       else if ( (s_Z(k) >= HTrans) .and. (s_Z(k) <= LCL/3.0d0 + 2.0d0*HTrans/3.0d0)) then
          xz_PressBasicZ(:,k) = &
            & PressSfc &
            & * (1.0d0 - Grav * HTrans / CpDry / TempSfc)**(CpDry/GasRDry) &
            & * ( (- s_Z(k) &
            &      + (TempSfc + (Gamma_1 - Grav/CpDry) * HTrans)/Gamma_1 ) &
            &     / ( TempSfc / Gamma_1 - Grav / CpDry / Gamma_1 * HTrans ) &
            &   )**(Grav / GasRDry / Gamma_1)
       else if ( (s_Z(k) >= LCL/3.0d0 + 2.0d0*HTrans/3.0d0) .and. (s_Z(k) <= 2.0d0*LCL/3.0d0 + HTrans/3.0d0)) then
          xz_PressBasicZ(:,k) = &
            & PressSfc &
            & * (1.0d0 - Grav * HTrans / CpDry / TempSfc)**(CpDry/GasRDry) &
            & * ( (- LCL / 3.0d0 + TempSfc / Gamma_1 &
            &      + (1.0d0/3.0d0 - Grav / CpDry / Gamma_1) * HTrans) &
            &     / ( TempSfc / Gamma_1 - Grav / CpDry / Gamma_1 * HTrans ) &
            &   )**(Grav / GasRDry / Gamma_1) &
            & * ( (- s_Z(k) + ( (Gamma_2 - Gamma_1)*LCL/3.0d0 + TempSfc &
            &      + ( - Grav/CpDry + Gamma_1/3.0d0 + 2.0d0 * Gamma_2/3.0d0 &
            &        )*HTrans ) /Gamma_2) &
            &     / ( - Gamma_1 * LCL / Gamma_2 / 3.0d0 &
            &         + TempSfc / Gamma_2 &
            &       + ( Gamma_1 / Gamma_2 / 3.0d0 - Grav / CpDry / Gamma_2 &
            &         ) * HTrans ) &
            &   )**(Grav / GasRDry / Gamma_2)
       else if ( (s_Z(k) >= 2.0d0*LCL/3.0d0 + HTrans/3.0d0) .and. (s_Z(k) <= LCL)) then
          xz_PressBasicZ(:,k) = &
            & PressSfc &
            & * (1.0d0 - Grav * HTrans / CpDry / TempSfc)**(CpDry/GasRDry) &
            & * ( (- LCL / 3.0d0 + TempSfc / Gamma_1 &
            &      + (1.0d0/3.0d0 - Grav / CpDry / Gamma_1) * HTrans) &
            &     / (TempSfc / Gamma_1 - Grav / CpDry / Gamma_1 * HTrans) &
            &   )**(Grav / GasRDry / Gamma_1) &
            & * ( ( - (1.0d0 + Gamma_1 / Gamma_2) * LCL / 3.0d0 &
            &     + TempSfc / Gamma_2 &
            &     + ( Gamma_1 / Gamma_2 / 3.0d0 - Grav / CpDry / Gamma_2 &
            &         + 1.0d0/3.0d0 ) * HTrans) &
            &     / ( - Gamma_1 * LCL / Gamma_2 / 3.0d0 &
            &         + TempSfc / Gamma_2 &
            &       + ( Gamma_1 / Gamma_2 / 3.0d0 - Grav / CpDry / Gamma_2 &
            &         ) * HTrans ) &
            &   )**(Grav / GasRDry / Gamma_2) &
            & * ( (- s_Z(k) + ( (2.0d0*Gamma_3 - Gamma_2 - Gamma_1)*LCL/3.0d0 &
            &      + TempSfc &
            &      + ( - Grav/CpDry + (Gamma_1 + Gamma_2 + Gamma_3)/3.0d0 &
            &         )*HTrans)/Gamma_3) &
            &     / ( - (Gamma_2 / Gamma_3 + Gamma_1 / Gamma_3) &
            &       * LCL / 3.0d0 &
            &     + TempSfc / Gamma_3 &
            &     + ( - Grav / CpDry / Gamma_3 + Gamma_1 / Gamma_3 / 3.0d0 &
            &         + Gamma_2 / Gamma_3 / 3.0d0) * HTrans) &
            &   )**(Grav / GasRDry / Gamma_3)
       else if ((s_Z(k) >= LCL) .and. (s_Z(k) <= LTP)) then
          xz_PressBasicZ(:,k) = &
            & dexp( &
            &   ChemData_SVapPress_AntoineA(12) &
            &   - ChemData_SVapPress_AntoineB(12) / xz_TempBasicZ(:,k))
       else
          xz_PressBasicZ(:,k) = &
            & dexp( &
            &   ChemData_SVapPress_AntoineA(12) &
            &   - ChemData_SVapPress_AntoineB(12) / xz_TempIso(1,1)) &
            & * dexp( &
            &   - Grav / GasRDry / xz_TempIso(1,1) * (s_Z(k) - LTP))
       end if
    end do

  !ǧΤ
  call MessageNotify( "M", "BasicEnv", "Basic State Atmospheric Profiles." )
  do k = RegZMin+1, DimZMax-1     
    write(*,*) "temp", k, s_Z(k), xz_TempBasicZ(1,k), xz_PressBasicZ(1,k)
  end do

  ! 2 ˳Ǽ
!  do i = DimXMin, DimXMax
!    xz_TempBasicZ(i,:)  = z_TempBasicZ  
!    xz_PressBasicZ(i,:) = z_PressBasicZ  
!  end do

  !
  call BoundaryXCyc_xz( xz_TempBasicZ )
  call BoundaryZSym_xz( xz_TempBasicZ )
  call BoundaryXCyc_xz( xz_PressBasicZ )
  call BoundaryZSym_xz( xz_PressBasicZ )
  
  !---------------------------------------------------------------
  ! 
  !---------------------------------------------------------------
  !ʿˤϰ
  do i = DimXMin, DimXMax      
    xza_MolFr(i,:,:) = za_MolFr
  end do    

  !Υ򺮹Ѵ
  do s = 1, SpcNum
    xza_MixRtBasicZ(:,:,s) = xza_MolFr(:,:,s) * MolWtWet(s) / MolWtDry
  end do

!  !ͤʤꤹʤ褦˺ͤͿ
!  where (xza_MixRtBasicZ <= 1.0d-20 )
!    xza_MixRtBasicZ = 1.0d-20
!  end where
  
  !
  call BoundaryXCyc_xza( xza_MixRtBasicZ )
  call BoundaryZSym_xza( xza_MixRtBasicZ )
      
  !---------------------------------------------------------------
  ! ʬ̤θ
  !---------------------------------------------------------------
  do s = 1, SpcNum
    xza_MixRtDivMolWt(:,:,s) = xza_MixRtBasicZ(:,:,s) / MolWtWet(s)
  end do
  
  xz_EffMolWtBasicZ = &
    & (1.0d0 + sum(xza_MixRtBasicZ,3) ) &
    & / ( MolWtDry * ((1.0d0 / MolWtDry) + sum(xza_MixRtDivMolWt,3)) )

  !  
  call BoundaryXCyc_xz( xz_EffMolWtBasicZ )
  call BoundaryZSym_xz( xz_EffMolWtBasicZ )  

  !---------------------------------------------------------------    
  ! 
  !---------------------------------------------------------------
  xz_PotTempBasicZ = &
    & xz_TempBasicZ * (PressBasis / xz_PressBasicZ) ** (GasRDry / CpDry) 

  !  
  call BoundaryXCyc_xz( xz_PotTempBasicZ )
  call BoundaryZSym_xz( xz_PotTempBasicZ )

  !---------------------------------------------------------------    
  ! ʡؿ
  !---------------------------------------------------------------
  xz_ExnerBasicZ = xz_TempBasicZ / xz_PotTempBasicZ    

  !
  call BoundaryXCyc_xz( xz_ExnerBasicZ )
  call BoundaryZSym_xz( xz_ExnerBasicZ )
  
  !---------------------------------------------------------------    
  ! ̩
  !---------------------------------------------------------------
  xz_DensBasicZ = &
    & PressBasis * (xz_ExnerBasicZ ** (CvDry / GasRDry)) &
    &  / (GasRDry * xz_PotTempBasicZ / xz_EffMolWtBasicZ)

  !
  call BoundaryXCyc_xz( xz_DensBasicZ )
  call BoundaryZSym_xz( xz_DensBasicZ )

  !---------------------------------------------------------------    
  ! ®
  !---------------------------------------------------------------
  xz_VelSoundBasicZ = &
    & sqrt ( &
    &   CpDry * GasRDry * xz_ExnerBasicZ * xz_PotTempBasicZ &
    &   / (CvDry * xz_EffMolWtBasicZ) &
    & )

  !
  call BoundaryXCyc_xz( xz_VelSoundBasicZ )
  call BoundaryZSym_xz( xz_VelSoundBasicZ )
 
  !----------------------------------------------------------
  ! BasicSet ⥸塼ͤ
  !----------------------------------------------------------
  call BasicSetArray_Init(                                  &
    & xz_PressBasicZ,    xz_ExnerBasicZ, xz_TempBasicZ,     &
    & xz_PotTempBasicZ,  xz_DensBasicZ,  xz_VelSoundBasicZ, &
    & xza_MixRtBasicZ, xz_EffMolWtBasicZ )


end subroutine BasicEnv
